mod lisp;
use crate::lisp::lisp;

fn main() {
    lisp!(
        (defun example (n1 n2 n3)
            (if (= n1 n2)
                (print "n1 equals n2"))
            (if (> n1 n3)
                (print "n1 is greater than n3")
                (print "n1 is less than or equal to n3"))
            (print (* n1 n2 n3))
        )

        (defvar funny 69)

        (example funny funny 42)
        (example 1 funny 3)

        (defun fib (n)
            (defvar i (- n 1))
            (defvar a 0)
            (defvar b 1)
            (defvar c (+ a b))
            (loop while (> i 0)
                (setvar a b)
                (setvar b c)
                (setvar c (+ a b))
                (setvar i (- i 1))
            )
            (return c)
        )

        (print "fib(8) is")
        (print (fib 8))

        (print "Counting to 5!")
        (dotimes (n 5)
            (print (+ n 1)))
    );
}
